var timePlan = new Array(days.length);	// days aj hours je definovane v subore DBvars.js
var signMode = false;
var copyMode = false;
var cutMode = false;
var RTCheckMode = false;
var checkMode = true;
var copyText = ["Kopirovat", "\">Kopirovat<\""];
var cutText = ["Vystrihnut", "\">Vystrihnut<\""];
var selectedTable = 0;
var selectedValues;
var editMode = -1;		// 0 - editovanie databaz, 1 - editovanie rozvrhu
var editDataBaseMode = 0;	// 0 - pridavanie, 1 - mazanie/modifikovanie
var colors = ["#FFAAAA", "#DD8888"];
var myBlue = "#8888DD";
var myGreen = "#88DD88";
var myYellow = "#DDDD88";
var lectureColor = "#000000";
var exerciseColor = "#0055FF";
var tables;
var tableLinks;
var dbStringPos = 0;
var modItems;
var NOTCHANGED = 0;
var ADDED = 1;
var MODIFIED = 2;
var DELETED = 3;

var debug = false;

function Debug() {
	debug = frames["cardLayout"].document.buttons.debug.checked;
}

function Item(numFields) {
	this.state = NOTCHANGED;	// 0 - not changed, 1 - added, 2 - modified, 3 - deleted
	this.data = new Array(numFields);
}

function Table(tableName) {
	this.name = tableName;
	this.cols = null;
	this.items = new Array();
	this.nextID = -1;	// ID-cko nasledujuceho noveho zaznamu
	this.cons = new Array();
	this.demo = new Array();
	this.normal_type = true;
	this.implicit_type = false;
	this.implicit_item = -1;
	this.addedIndex = -1;	// index, kde zacinaju novo pridane polozky
	this.status = NOTCHANGED;	// 0 - not changed , 2 - modified
	this.select_dep = new Array();

	this.Select = Select;
	this.ColumnNumber = ColumnNumber;
	this.DemoString = DemoString;
	this.TranslateIndex = TranslateIndex;
	this.toString = TableToString;
	this.GetColumnValues = GetColumnValues;
	this.ItemNumber = ItemNumber;
	this.GetStructure = GetStructure;
	this.Union = Union;
}

function Union(otherTable) {	// zjednotenie tabuliek s rovnakou strukturou
	var i, myValues;

	if(this.cols != otherTable.cols) {	// musia mat rovnaku strukturu
		alert("Tabuky nemaju rovnaku truktru");
	}
	else {
		myValues = otherTable.GetColumnValues("ID", false);
		for(i=0 ; i<myValues.length ; i++) {
			if(this.ItemNumber(myValues[i]) == -1) {
				this.items.push(otherTable.items[i]);
			}
		}
	}
}

function GetStructure() {
	var newTable;

	newTable = new Table("");
	newTable.cols = this.cols;

	return(newTable);
}

function ItemNumber(x) {
	var i, j, k, y, z;
	var myValues = this.GetColumnValues("ID", true);

	y = parseInt(x, 10);

	i = 0;
	j = myValues.length - 1;

	do {
		k = Math.floor((i + j) / 2);
		z = parseInt(myValues[k], 10);
		if(x > z)
			i = k + 1;
		else
			j = k - 1;
	}while((z != x) && (i <= j));

	if(myValues[k] != x)
		return(-1);
	else
		return(k);
}

function GetColumnValues(col, alsoDeletedItems) {
	var myValues = new Array();
	var i, colNum, alreadyThere;

	if(isNaN(col))	// col je nazov stlpca
		colNum = this.ColumnNumber(col);
	else		// col je cislo stlpca
		colNum = col;
	if(colNum != -1) {
		for(i=0 ; i<this.items.length ; i++) {
			if(alsoDeletedItems || this.items[i].state != DELETED) {
				alreadyThere = false;
				for(j=0 ; j<myValues.length ; j++) {
					if(this.items[i].data[colNum] == myValues[j])
						alreadyThere = true;
				}
				if(alreadyThere == false)
					myValues.push(this.items[i].data[colNum]);
			}
		}
		return(myValues);
	}
	else {
		return(null);
	}
}

function TableToString(prompt) {
	var i, j, myValue;

	myValue = prompt+"\n";
	myValue += "name: "+this.name+"\n";
	myValue += "normal_type: "+this.normal_type+"\n";
	myValue += "nextID: "+this.nextID+"\n";
	myValue += "Cols: ";
	for(i=0 ; i<this.cols.length ; i++) {
		if(i != 0)
			myValue += ", ";
		myValue += this.cols[i];
	}
	myValue += "\nItems:\n";
	for(i=0 ; i<this.items.length ; i++) {
		for(j=0 ; j<this.cols.length ; j++) {
			if(j != 0)
				myValue += ", ";
			myValue += this.items[i].data[j];
		}
		myValue += "\n";
	}
	myValue += "\nSelect Dependence:\n";
	for(i=0 ; i<this.select_dep.length ; i++) {
		myValue += tables[this.select_dep[i].table].name+", ";
		myValue += tables[this.select_dep[i].table].cols[this.select_dep[i].condCol]+"\n";
		myValue += tables[this.select_dep[i].table].cols[this.select_dep[i].selCol]+"\n";
	}

	alert(myValue);
}

function TranslateIndex(itemIndex) {
	var i;

	for(i=0 ; i<this.items.length && itemIndex >= 0 ; i++) {
		if(this.items[i].state != DELETED)
			itemIndex--;
	}

	return(this.items[i-1].data[this.ColumnNumber("ID")]);	//	vratim ID-cko daneho zaznamu
}

function DemoString(itemIndex) {
	var i, myValue;

	if(itemIndex == -1)
		myValue = "<B>neplatn odkaz</B>";
	else {
		myValue = "";
		for(i=0 ; i<this.demo.length ; i++) {
			if(i != 0)
				myValue += " ";
			myValue += this.items[itemIndex].data[this.demo[i]];
		}

		if(this.items[itemIndex].state == DELETED)
			myValue += "<B> (zmazan)</B>";
	}

	return(myValue);
}

function ColumnNumber(col) {
	var i;

	for(i=0 ; i<this.cols.length ; i++) {
		if(this.cols[i] == col)
			return(i);
	}

	return(-1);
}

// col moze byt retazec (nazov stlpca) alebo cislo (index stlpca)
function Select(col, value) {
	var mySelect;
	var i, colNum;

	if(isNaN(col))	// col je nazov stlpca
		colNum = this.ColumnNumber(col);
	else		// col je cislo stlpca
		colNum = col;
	if(colNum != -1) {
		mySelect = new Table("select");
		mySelect.cols = this.cols;
		mySelect.cons = this.cons;
		mySelect.demo = this.demo;
		mySelect.items = new Array();

		for(i=0 ; i<this.items.length ; i++) {
			if(this.items[i].state != DELETED) {
				if(this.items[i].data[colNum] == value) {
					mySelect.items.push(new Item(this.cols.length));
					mySelect.items[mySelect.items.length-1].data = this.items[i].data;
				}
			}
		}
		return(mySelect);
	}
	else
		return(this);
}

function Cell() {
	var i;

	this.text = "";
	this.checked = false;
	this.merged = false;
	this.colSpan = 1;
	this.copy = false;
	this.cut = false;
	this.data = new Array();	// data priradene konkretnej bunke
	this.lecture = true;
	for(i=0 ; i<tables.length ; i++) {
		if(tables[i].normal_type)
			this.data.push(-1);
	}

	this.MergeData = MergeData;
	this.ClearData = ClearData;
	this.SetData = SetData;
}

function ModItem(num, numFields) {
	this.num = num;		// cislo zaznamu
	this.data = new Array(numFields);	// polozky zaznamu
}

function SelectDep(implicitTableNum, tableNum, condCol, selCol) {
	this.implicitTable = implicitTableNum;	// cislo tabulky, v ktorej hladam implicitnu hodnotu
	this.table = tableNum;	// cislo tabulky
	this.condCol = condCol;	// cislo stlpca, ktory je v podmienke
	this.selCol = selCol;	// cislo stlpca, ktoreho hodnoty vyberam
}

function unload() {
	top.location = "disconnect.php3";
}

function init() {
	var i, j;

	fillDB();

	for(i=0 ; i<days.length ; i++)
		timePlan[i] = new Array(hours.length);

	for(i=0 ; i<days.length ; i++)
		for(j=0 ; j<hours.length ; j++)
			timePlan[i][j] = new Cell();

	Card(0);
}

function getDbSubString() {
	var pos = dbString.indexOf("|", dbStringPos);
	var str = dbString.substr(dbStringPos, pos-dbStringPos);

	dbStringPos += (pos - dbStringPos + 1);
	return(str);
}

function fillDB() {
	var i, j, k, numTables, numFields, numItems, demo, cons, numDeps, tableNum, condCol, selCol;

	numTables = parseInt(getDbSubString(), 10);
	tables = new Array(numTables);
	tableLinks = new Array(numTables);
	for(i=0 ; i<numTables ; i++) {
		tables[i] = new Table(getDbSubString());
		tables[i].normal_type = (parseInt(getDbSubString(), 10) == 1) ? true : false;
		tables[i].implicit_type = (parseInt(getDbSubString(), 10) == 1) ? true : false;
		tables[i].nextID = parseInt(getDbSubString(), 10);

		if(tables[i].normal_type == true) {
			numDeps = parseInt(getDbSubString(), 10);
			for(j=0 ; j<numDeps ; j++) {
				implicitTableNum = parseInt(getDbSubString(), 10);
				tableNum = parseInt(getDbSubString(), 10);
				condCol = parseInt(getDbSubString(), 10);
				selCol = parseInt(getDbSubString(), 10);
				tables[i].select_dep.push(new SelectDep(implicitTableNum, tableNum, condCol, selCol));
			}
		}

		numFields = parseInt(getDbSubString(), 10);
		tables[i].cols = new Array(numFields);
		for(j=0 ; j<numFields ; j++) {
			tables[i].cols[j] = getDbSubString();
		}

		cons = parseInt(getDbSubString(), 10);
		for(j=0 ; j<16 ; j++) {
			if(cons & 1) {
				tables[i].cons.push(j);
			}
			cons = cons >> 1;
		}

		demo = parseInt(getDbSubString(), 10);
		for(j=0 ; j<16 ; j++) {
			if(demo & 1) {
				tables[i].demo.push(j);
			}
			demo = demo >> 1;
		}

		numItems = parseInt(getDbSubString(), 10);
		for(j=0 ; j<numItems ; j++) {
			tables[i].items.push(new Item(numFields));
			for(k=0 ; k<numFields ; k++) {
				tables[i].items[j].data[k] = getDbSubString();
			}
		}
	}
}

function Look() {
	window.open("prezeranie.html", "db");
	window.open("blank.html", "tp");
	editMode = -1;
}

function Card(number) {
	var myDocument = frames["db"].document;
	var myTable;
	var i, j, myValue, caption, colspan, captionColspan;
	var myCol, mySelect, mySelectCol, myChecked;

	if(number != editMode)
		selectedTable = 0;

	myTable = tables[selectedTable];

	myDocument.open();
	myDocument.write("<HTML>\n");
	myDocument.write("<HEAD><META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=iso-8859-2\"></HEAD>\n");
	myDocument.write("<BODY>\n");
	myDocument.write("<FORM NAME=dataBase>\n");
	myDocument.write("<TABLE BORDER=1 CELLSPACING=0 CELLPADDING=5>\n");
	if(number == 0) {
		caption = "Editovanie tabuliek";
		colspan = 3;
		captionColspan = 3;
	}
	else if(number == 1) {
		caption = "Editovanie rozvrhu";
		colspan = 2;
		captionColspan = 4;
	}
	myDocument.write("<TR BGCOLOR="+myBlue+">\n<TD COLSPAN="+captionColspan+" ALIGN=center><B>"+caption+"</B>\n");
	myDocument.write("<TR BGCOLOR="+myBlue+">\n<TD COLSPAN="+colspan+"><B>Tabuka:</B>\n");
	myDocument.write("<SELECT NAME=selectDataBase OnChange=\"parent.ChangeDb("+number+");\">\n");
	for(i=0 ; i<tables.length ; i++) {
		if(number == 0 || tables[i].normal_type) {	// pri editacii databaz chceme vidiet vsetky tabulky, inak len normalne (nie vazobne)
			if(i == selectedTable)
				myDocument.write("<OPTION SELECTED>"+tables[i].name+"\n");
			else
				myDocument.write("<OPTION>"+tables[i].name+"\n");
		}
	}
	myDocument.write("</SELECT>\n");
	if(number == 1)
		myDocument.write("<TD><B>Implicitn:</B><TD><B>Nastavenia rozvrhu:</B>\n");
	myDocument.write("</TR>\n");
	if(number == 0) {
		myDocument.write("<TR BGCOLOR="+myGreen+">\n<TD><INPUT TYPE=button VALUE=prida OnClick=\"parent.ShowAddDelModCard(0);\">\n");
		myDocument.write("<TD><INPUT TYPE=button VALUE=zmaza/modifikova OnClick=\"parent.ShowAddDelModCard(1);\">\n");
		myDocument.write("<TD><INPUT TYPE=button VALUE=\"uk/zap zmeny do databzy\" OnClick=\"parent.ChangesToDataBase();\">\n");
	}
	else if(number == 1) {
		myDocument.write("<TR BGCOLOR="+myGreen+" VALIGN=top ALIGN=center><TD>\n");
		myDocument.write("<SELECT NAME=items SIZE=8>\n");

		selectedValues = SelectValues();

		for(i=0 ; i<selectedValues.length ; i++) {
			myValue = myTable.DemoString(myTable.ItemNumber(selectedValues[i]));
			myDocument.write("<OPTION>"+myValue+"\n");
		}

		myDocument.write("</SELECT>\n");
		myDocument.write("<TD><INPUT TYPE=button VALUE=\"prida medzi implicitn\" OnClick=\"parent.AddToImplicit();\">\n");
		myDocument.write("<BR><INPUT TYPE=button VALUE=\"prida do rozvrhu\" OnClick=\"parent.AddToPlan();\">\n");
		myDocument.write("<TD ALIGN=left>\n");
		for(i=0 ; i<tables.length ; i++) {
			if(tables[i].implicit_type) {
				if(tables[i].implicit_item == -1) {
					myChecked = "";
					myValue = "-";
				}
				else {
					myChecked = " CHECKED";
					myValue = tables[i].DemoString(tables[i].ItemNumber(tables[i].implicit_item));
				}
				myDocument.write("<INPUT TYPE=checkbox NAME=\"i_"+i+"\""+myChecked+" OnClick=\"parent.CancelImplicit("+i+")\">\n");
				myDocument.write(tables[i].name+": ");
				myDocument.write("<B>"+myValue+"</B><BR>\n");
			}
		}
		myDocument.write("<TD ALIGN=left>\n");
		myDocument.write("<INPUT TYPE=checkbox NAME=signMode OnClick=\"parent.SetSignMode();\""+(signMode==true ? " CHECKED" : "")+">Oznaova koprovan a vystrihovan bunky<BR><HR SIZE=1>\n");
		myDocument.write("<INPUT TYPE=checkbox NAME=RTCheckModeOn OnClick=\"parent.SetRTCheckMode(true);\""+(checkMode==true && RTCheckMode==true ? " CHECKED" : "")+">Automatick kontroly kolzi po kadej zmene buniek<BR>\n");
		myDocument.write("<INPUT TYPE=checkbox NAME=RTCheckModeOff OnClick=\"parent.SetRTCheckMode(false);\""+(checkMode==true && RTCheckMode==false ? " CHECKED" : "")+">Automatick kontroly kolzi pri uchovvan rozvrhu<BR>\n");
	}
	myDocument.write("</TR>\n");
	myDocument.write("</TABLE>\n");
	myDocument.write("</FORM>\n");
	myDocument.write("</BODY>\n</HTML>\n");
	myDocument.close();

	if(number == 0 && editMode != 0)
		ShowAddDelModCard(editDataBaseMode);
	else if(number == 1 && editMode != 1)
		ShowTimePlan();

	editMode = number;
}

function CancelImplicit(tableNumber) {
	if(frames["db"].document.dataBase["i_"+tableNumber].checked)
		frames["db"].document.dataBase["i_"+tableNumber].checked = false
	else {
		tables[tableNumber].implicit_item = -1;
		for(i=1 ; i<=days.length ; i++)
			for(j=1 ; j<=hours.length ; j++)
				timePlan[i-1][j-1].data[tableNumber] = -1;
		Card(1);
		ShowTimePlan();
	}
}

function ChangeDb(num) {
	selectedTable = frames["db"].document.dataBase.selectDataBase.selectedIndex;

	if(num == 0)
		ShowAddDelModCard(editDataBaseMode);
	else if(num == 1)
		Card(num);
}

function AddToImplicit() {
	var myDocument = frames["db"].document;
	var i, myValue;

	if(tables[selectedTable].implicit_type) {
		myValue = selectedValues[frames["db"].document.dataBase["items"].selectedIndex];

		tables[selectedTable].implicit_item = myValue;
		for(i=1 ; i<=days.length ; i++)
			for(j=1 ; j<=hours.length ; j++)
				timePlan[i-1][j-1].data[selectedTable] = tables[selectedTable].implicit_item;
		Card(1);
		ShowTimePlan();
	}
	else
		alert("Poloky tejto tabuky nemu by implicitn.");

}

function DelItemFromArray(array, num) {
	var i;

	for(i=num ; (i+1)<array.length ; i++) {
		array[i] = array[i+1];
	}
	array.pop();
}

function SelectValues() {
	var i, j, k;
	var myTable = tables[selectedTable];
	var partialSelect, totalSelect, myValues;
	var myColumn, selected;

	selected = false;
	for(i=0 ; i<myTable.select_dep.length ; i++) {
		totalSelect = tables[myTable.select_dep[i].table].GetStructure();
		if(i == 0) {
			if(tables[myTable.select_dep[i].implicitTable].implicit_item != -1) {
				myValues = new Array();
				myValues.push(tables[myTable.select_dep[i].implicitTable].implicit_item);
			}
			else
				myValues = null;
		}
		if(myValues != null) {
			for(j=0 ; j<myValues.length ; j++) {
				partialSelect = tables[myTable.select_dep[i].table].Select(myTable.select_dep[i].condCol, myValues[j]);
				totalSelect.Union(partialSelect);
			}
			myValues = totalSelect.GetColumnValues(myTable.select_dep[i].selCol, false);
			selected = true;
		}
		else {
			totalSelect = myTable;
			selected = false;
		}
	}

	if(selected)
		return(totalSelect.GetColumnValues(myTable.select_dep[i-1].selCol, false));
	else
		return(totalSelect.GetColumnValues("ID", false));
}
