function CompareCells(c1, c2) {
	var myLength, statusOK;

	myLength = c1.data.length;	// c1.data.length == c2.data.length

	statusOK = true;
	for(i=0 ; i<myLength ; i++) {
		if((c1.data[i] != c2.data[i]) && ((c1.data[i] != -1) && (c2.data[i] != -1))) {
			statusOK = false;
			break;
		}
	}

	return(statusOK);
}

function MergeData(otherCell) {
	for(i=0 ; i<this.data.length ; i++) {
		if(this.data[i] == -1)
			this.data[i] = otherCell.data[i];
	}	
}

function ClearData() {
	for(i=0 ; i<this.data.length ; i++) {
		this.data[i] = -1;
	}	
}

function SetData(otherCell) {
	for(i=0 ; i<this.data.length ; i++) {
		this.data[i] = otherCell.data[i];
	}	
}

function Copy() {
	var i, j, k, l;

	if(!signMode && cutMode) {
		alert("Mate zapnute vystrihovanie!");
		return;
	}

	for(i=1 ; i<=days.length ; i++) {
		for(j=1 ; j<=hours.length ; j++) {
			if(timePlan[i-1][j-1].checked) {
				// nasleduje porovnanie s ostatnymi bunkami
				for(k=1 ; k<=days.length ; k++) {
					for(l=1; l<=hours.length ; l++) {
						if((timePlan[k-1][l-1].checked || timePlan[k-1][l-1].cut || timePlan[k-1][l-1].copy) && !CompareCells(timePlan[k-1][l-1], timePlan[i-1][j-1])) {	// rozdielne polozky v bunkach
							alert("Niektor poloky v bunkch s rozdielne - nemono ich zjednoti");
							return;
						}
					}
				}

				timePlan[i-1][j-1].copy = true;
				timePlan[i-1][j-1].cut = false;
				timePlan[i-1][j-1].checked = false;
				frames["tp"].document.time_plan["C"+i+"_"+j].checked = false;
			}

			j += timePlan[i-1][j-1].colSpan - 1;
		}
	}

	copyMode = true;

	if(signMode)
		ShowTimePlan();
	else
		frames["tp"].document.time_plan["stornocopy"].checked = true;
}

function Cut() {
	var i, j, k;

	if(!signMode && copyMode) {
		alert("Mate zapnute Kopirovanie!");
		return;
	}

	for(i=1 ; i<=days.length ; i++) {
		for(j=1 ; j<=hours.length ; j++) {
			if(timePlan[i-1][j-1].checked) {
				// nasleduje porovnanie s ostatnymi bunkami
				for(k=1 ; k<=days.length ; k++) {
					for(l=1 ; l<=hours.length ; l++) {
						if((timePlan[k-1][l-1].checked || timePlan[k-1][l-1].copy || timePlan[k-1][l-1].cut) && !CompareCells(timePlan[k-1][l-1], timePlan[i-1][j-1])) {	// rozdielne polozky v bunkach
							alert("Niektor poloky v bunkch s rozdielne - nemono ich zjednoti");
							return;
						}
					}
				}

				timePlan[i-1][j-1].cut = true;
				timePlan[i-1][j-1].copy = false;
				timePlan[i-1][j-1].checked = false;
				frames["tp"].document.time_plan["C"+i+"_"+j].checked = false;
			}

			j += timePlan[i-1][j-1].colSpan - 1;
		}
	}

	cutMode = true;

	if(signMode)
		ShowTimePlan();
	else
		frames["tp"].document.time_plan["stornocut"].checked = true;
}

function Paste() {
	var i, j, k;
	var tempCell;

	cutMode = false;
	copyMode = false;

	tempCell = new Cell();
	for(i=1 ; i<=days.length ; i++) {
		for(j=1 ; j<=hours.length ; j++) {
			if(timePlan[i-1][j-1].copy) {
				tempCell.MergeData(timePlan[i-1][j-1]);
				timePlan[i-1][j-1].copy = false;
			}

			if(timePlan[i-1][j-1].cut) {
				tempCell.MergeData(timePlan[i-1][j-1]);
				timePlan[i-1][j-1].cut = false;
				timePlan[i-1][j-1].ClearData();
			}

			j += timePlan[i-1][j-1].colSpan - 1;
		}
	}

	for(i=1 ; i<=days.length ; i++) {
		for(j=1 ; j<=hours.length ; j++) {
			if(timePlan[i-1][j-1].checked) {
				timePlan[i-1][j-1].SetData(tempCell);
			}

//			timePlan[i-1][j-1].checked = false;
			j += timePlan[i-1][j-1].colSpan - 1;
		}
	}

	ShowTimePlan();
}

function Storno(mode) {
	if(mode == 0 && frames["tp"].document.time_plan["stornocut"].checked == true) {
		frames["tp"].document.time_plan["stornocut"].checked = false;
		return;
	}
	else if(mode == 1 && frames["tp"].document.time_plan["stornocopy"].checked == true) {
		frames["tp"].document.time_plan["stornocopy"].checked = false;
		return;
	}

	if(mode == 0)
		cutMode = false;
	else
		copyMode = false;

	for(i=1 ; i<=days.length ; i++) {
		for(j=1 ; j<=hours.length ; j++) {
			if(mode == 0 && timePlan[i-1][j-1].cut) {
				timePlan[i-1][j-1].cut = false;
			}
			else if(mode == 1 && timePlan[i-1][j-1].copy) {
				timePlan[i-1][j-1].copy = false;
			}

			j += timePlan[i-1][j-1].colSpan - 1;
		}
	}

	if(signMode)
		ShowTimePlan();
}

function Merge() {
	var i, j, k;
	var tempCell;

	tempCell = new Cell();

	for(i=1 ; i<=days.length ; i++) {
		for(j=1 ; j<=hours.length ; j++) {
			if(timePlan[i-1][j-1].checked) {
				tempCell.SetData(timePlan[i-1][j-1]);
				for(k=j+timePlan[i-1][j-1].colSpan ; k<=hours.length && timePlan[i-1][k-1].checked; k+=timePlan[i-1][k-1].colSpan) {
					if(!CompareCells(tempCell, timePlan[i-1][k-1])) {
						alert("Niektor poloky v bunkch s rozdielne - nemono ich zjednoti");
						return;
					}
					tempCell.MergeData(timePlan[i-1][k-1]);
				}
				for(k=j+timePlan[i-1][j-1].colSpan ; k<=hours.length && timePlan[i-1][k-1].checked; k+=timePlan[i-1][k-1].colSpan) {
					timePlan[i-1][j-1].MergeData(tempCell);
					timePlan[i-1][j-1].colSpan += timePlan[i-1][k-1].colSpan;
					timePlan[i-1][k-1].merged = true;
					timePlan[i-1][k-1].checked = false;
				}
			}

//			timePlan[i-1][j-1].checked = false;
			j += timePlan[i-1][j-1].colSpan - 1;
		}
	}

	ShowTimePlan();
}

function Split() {
	var i, j, k;

	for(i=1 ; i<=days.length ; i++) {
		for(j=1 ; j<=hours.length ; j++) {
			if(timePlan[i-1][j-1].checked) {
				for(k=j+1 ; k<=(j + timePlan[i-1][j-1].colSpan - 1) && k<=hours.length; k++) {
					timePlan[i-1][k-1].SetData(timePlan[i-1][j-1]);
					timePlan[i-1][k-1].merged = false;
					timePlan[i-1][k-1].checked = true;
					timePlan[i-1][k-1].colSpan = 1;
				}
				timePlan[i-1][j-1].colSpan = 1;
			}

			j += timePlan[i-1][j-1].colSpan - 1;
		}
	}

	ShowTimePlan();
}

function Clear() {
	var i, j, k;

	for(i=1 ; i<=days.length ; i++) {
		for(j=1 ; j<=hours.length ; j++) {
			if(timePlan[i-1][j-1].checked) {
				timePlan[i-1][j-1].ClearData();
				timePlan[i-1][j-1].lecture = true;
			}
		}
	}

	ShowTimePlan();
}

function All() {
	var i, j;

	if(frames["tp"].document.time_plan["A"].checked == true)
		toggle = true;
	else
		toggle = false;

	for(i=1 ; i<=days.length ; i++) {
		frames["tp"].document.time_plan["R"+i].checked = toggle;
		for(j=1 ; j<=hours.length ; j++) {
			frames["tp"].document.time_plan["C"+i+"_"+j].checked = toggle;
			timePlan[i-1][j-1].checked = toggle;

			j += timePlan[i-1][j-1].colSpan - 1;
		}
	}

	for(i=1 ; i<=hours.length ; i++) {
		frames["tp"].document.time_plan["C"+i].checked = toggle;
	}
}

function Col(x) {
	var i;

	if(frames["tp"].document.time_plan["C"+x].checked == true)
		toggle = true;
	else
		toggle = false;

	for(i=1 ; i<=days.length ; i++) {
		if(!timePlan[i-1][x-1].merged) {
			frames["tp"].document.time_plan["C"+i+"_"+x].checked = toggle;
			timePlan[i-1][x-1].checked = toggle;
		}
	}
}

function Row(x) {
	var i;

	if(frames["tp"].document.time_plan["R"+x].checked == true)
		toggle = true;
	else
		toggle = false;

	for(i=1 ; i<=hours.length ; i++) {
		frames["tp"].document.time_plan["C"+x+"_"+i].checked = toggle;
		timePlan[x-1][i-1].checked = toggle;

		i += timePlan[x-1][i-1].colSpan - 1;
	}
}

function AddToPlan() {
	var myValue, societyAdding, specTableIndex, yearTableIndex, spec_year_socSelect;
	var slectedYears, selectedSocs;

	myValue = selectedValues[frames["db"].document.dataBase["items"].selectedIndex];

	// ak pridavam kruzok musim pridat aj zodpovedajuci rocnik a specializaciu
	societyAdding = false;
	if(tables[selectedTable].name == "krok") {
		specTableIndex = TableWithName("pecializcia");
		yearTableIndex = TableWithName("ronk");
		spec_year_socTableIndex = TableWithName("pecializcia_ronk_krok");

		spec_year_socSelect = tables[spec_year_socTableIndex].Select("krok", myValue);
		selectedYears = spec_year_socSelect.GetColumnValues("ronk", false);	// mal by tam byt len jeden
		selectedSocs = spec_year_socSelect.GetColumnValues("pecializcia", false);	// dtto

		societyAdding = true;
	}

	if(myValue) {
		for(i=1 ; i<=days.length ; i++) {
			for(j=1 ; j<=hours.length ; j++) {
				if(timePlan[i-1][j-1].checked) {
					timePlan[i-1][j-1].data[selectedTable] = myValue;
					if(societyAdding) {
						timePlan[i-1][j-1].data[yearTableIndex] = selectedYears[0];
						timePlan[i-1][j-1].data[specTableIndex] = selectedSocs[0];
					}
				}
				j += timePlan[i-1][j-1].colSpan - 1;
			}
		}

		ShowTimePlan();
	}
}

function ClickCB(x, y) {
	if(frames["tp"].document.time_plan["C"+x+"_"+y].checked == true)
		timePlan[x-1][y-1].checked = true;
	else
		timePlan[x-1][y-1].checked = false;
}

function Lecture_Exercise() {
	var i, j, k;

	for(i=1 ; i<=days.length ; i++) {
		for(j=1 ; j<=hours.length ; j++) {
			if(timePlan[i-1][j-1].checked)
				timePlan[i-1][j-1].lecture = (timePlan[i-1][j-1].lecture == true) ? false : true;
		}
	}

	ShowTimePlan();
}

function ShowTimePlan() {
	var i, j, k, l, m, n, checkCopyMode, checkCutMode, hiddenText, somethingInserted;
	var myDocument = frames["tp"].document;

	checkCutMode = (cutMode) ? " CHECKED" : "";
	checkCopyMode = (copyMode) ? " CHECKED" : "";

	myDocument.open();
	myDocument.write("<HTML>\n");
	myDocument.write("<HEAD><META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=iso-8859-2\"></HEAD>\n");
	myDocument.write("<BODY>\n");
	myDocument.write("<FORM NAME=time_plan METHOD=post ACTION=http:updateTimePlan.php3>\n<TABLE BORDER=1 CELLSPACING=1 CELLPADDING=5>\n");
	myDocument.write("<INPUT TYPE=hidden NAME=checkCollisions VALUE=\""+((checkMode == true) ? 1 : 0)+"\">");
	myDocument.write("<TR ALIGN=center BGCOLOR="+myBlue+">\n<TH><INPUT TYPE=button VALUE=ulo OnClick=\"parent.SubmitTimePlan();\">\n<TH>&nbsp;\n");

	for(i=0 ; i<hours.length ; i++) {
		myDocument.write("<TH ALIGN=left>"+hours[i]+"\n");
	}
	myDocument.write("</TR>\n");
	myDocument.write("<TR ALIGN=right BGCOLOR="+myBlue+">\n<TD>&nbsp;\n<TD><INPUT TYPE=checkbox NAME=A OnClick=\"parent.All();\">\n");
	for(i=1 ; i<=hours.length ; i++) {
		myDocument.write("<TD ALIGN=left><INPUT TYPE=checkbox NAME=C"+i+" OnClick=\"parent.Col("+i+");\">\n");
	}
	myDocument.write("</TR>\n");

	for(i=0 ; i<tables.length ; i++) {
		if(tables[i].implicit_type)
			myDocument.write("<INPUT TYPE=hidden NAME=II"+i+" VALUE=\""+tables[i].implicit_item+"\">");
	}

	for(i=1 ; i<=days.length ; i++) {
		myDocument.write("<TR ALIGN=right>\n<TH BGCOLOR="+myBlue+">"+days[i-1]+"<TD BGCOLOR="+myBlue+" VALIGN=top><INPUT TYPE=checkbox NAME=R"+i+" OnClick=\"parent.Row("+i+");\">\n");
		for(j=1, l=0, k=l % 2 ; j<=hours.length ; j++, l++, k = l % 2) {
			if(signMode) {
				if(timePlan[i-1][j-1].copy)
					color = myYellow;
				else if(timePlan[i-1][j-1].cut)
					color = myGreen;
				else
					color = colors[k];
			}
			else
				color = colors[k];

			if(timePlan[i-1][j-1].colSpan > 0)
				myDocument.write("<TD ALIGN=left VALIGN=top BGCOLOR="+color+" COLSPAN="+timePlan[i-1][j-1].colSpan+">");
			else
				myDocument.write("<TD ALIGN=left VALIGN=top BGCOLOR="+color+">");

			if(timePlan[i-1][j-1].checked)
				myDocument.write("<INPUT TYPE=checkbox NAME=C"+i+"_"+j+" OnClick=\"parent.ClickCB("+i+", "+j+");\" CHECKED>");
			else
				myDocument.write("<INPUT TYPE=checkbox NAME=C"+i+"_"+j+" OnClick=\"parent.ClickCB("+i+", "+j+")\">");

			hiddenText = "";
			somethingInserted = false;
			for(m=0, n=0 ; m<tables.length ; m++) {
				if(tables[m].normal_type) {
					if((timePlan[i-1][j-1].data[m] != -1) && !(tables[m].implicit_type && tables[m].implicit_item != -1)) {
						hiddenText += timePlan[i-1][j-1].data[m] + "|";
						somethingInserted = true;
					}
					else
						hiddenText += "-1|";
					if(!tables[m].normal_type)
						continue;
					if(timePlan[i-1][j-1].data[m] == -1)
						continue;
					if(tables[m].implicit_type && tables[m].implicit_item != -1)
						continue;
					if(n != 0)
						myDocument.write("<BR>");
					if(!timePlan[i-1][j-1].lecture)
						myDocument.write("<FONT COLOR="+exerciseColor+">");

					myDocument.write(tables[m].DemoString(tables[m].ItemNumber(timePlan[i-1][j-1].data[m])));

					if(!timePlan[i-1][j-1].lecture)
						myDocument.write("</FONT>");

					n++;	// continue preskoci tento prikaz;
				}
			}
			if(somethingInserted != "") {
				hiddenText += (timePlan[i-1][j-1].lecture == true) ? 1 : 0;
				myDocument.write("<INPUT TYPE=hidden NAME=TI"+i+"_"+j+" VALUE=\""+hiddenText+"\">");
				myDocument.write("<INPUT TYPE=hidden NAME=CS"+i+"_"+j+" VALUE=\""+timePlan[i-1][j-1].colSpan+"\">");
			}
			j += timePlan[i-1][j-1].colSpan - 1;	//1 sa pripocita v cikle for (j++)
		}
		myDocument.write("</TR>\n");
	}
	myDocument.write("</TABLE><BR>\n");
	myDocument.write("<TABLE BORDER=1 CELLSPACING=0 CELLPADDING=0 BGCOLOR="+myBlue+">\n");
	myDocument.write("<TR ALIGN=left BGCOLOR="+myBlue+"><TD COLSPAN=7><B>Tieto tlatka vykonvaj innosti s oznaenmi bunkami v rozvrhu</B></TR>\n");
	myDocument.write("<TR ALIGN=center BGCOLOR="+myBlue+"><TD COLSPAN=4>&nbsp;<TD><INPUT TYPE=checkbox NAME=stornocut OnClick=\"parent.Storno(0);\""+checkCutMode+">\n<TD><INPUT TYPE=checkbox NAME=stornocopy VALUE=Storno OnClick=\"parent.Storno(1);\""+checkCopyMode+"><TD>&nbsp;</TR>\n");
	myDocument.write("<TR ALIGN=center><TD><INPUT TYPE=button VALUE=cvienia/prednky OnClick=\"parent.Lecture_Exercise();\">\n<TD><INPUT TYPE=button VALUE=spoji OnClick=\"parent.Merge();\">\n<TD><INPUT TYPE=button VALUE=rozdeli OnClick=\"parent.Split();\">\n<TD><INPUT TYPE=button VALUE=zmaza OnClick=\"parent.Clear();\">\n<TD><INPUT TYPE=button VALUE=vystrihn OnClick=\"parent.Cut();\">\n<TD><INPUT TYPE=button VALUE=koprova OnClick=\"parent.Copy();\">\n<TD><INPUT TYPE=button VALUE=vloi OnClick=\"parent.Paste();\"></TR>\n");
	myDocument.write("</TABLE>\n");
	myDocument.write("</FORM>\n</BODY>\n</HTML>\n");
	myDocument.close();
}

function SubmitTimePlan() {
	editMode = -1;
        frames["tp"].document.time_plan.submit();
}

function SetSignMode() {
	if(frames["db"].document.dataBase["signMode"].checked == true)
		signMode = true;
	else
		signMode = false;
}

function SetRTCheckMode(turnOnRTCheckMode) {
	if(turnOnRTCheckMode) {
		frames["db"].document.dataBase["RTCheckModeOn"].checked = false;
		alert("Automatick kontroly kolzi po kadej zmene buniek nie s v tejto verzii implementovan");
/*		if(frames["db"].document.dataBase["RTCheckModeOn"].checked == true) {
			frames["db"].document.dataBase["RTCheckModeOff"].checked = false;
			checkMode = true;
			RTCheckMode = true;
		}
		else {
			checkMode = false;
		}
*/
	}
	else {
		if(frames["db"].document.dataBase["RTCheckModeOff"].checked == true) {
			frames["db"].document.dataBase["RTCheckModeOn"].checked = false;
			checkMode = true;
			RTCheckMode = false;
		}
		else {
			checkMode = false;
		}
		ShowTimePlan();
	}
}
